import java.util.*;
public class Listenverwalter {
  private int zaehler = 0;
  private List<Integer> testListe;

  public Listenverwalter() {
    testListe = new List<Integer>();
    zaehler = 0;
  }

public void erzeugeZufallsliste(int pAnzahl) {
  Random generator = new Random(pAnzahl);
  zaehler = 0;
  testListe = new List<Integer>();
  for (int i = 1; i <= pAnzahl; i++) {
    int zahl =  generator.nextInt(77777) + 1;
    testListe.append(new Integer(zahl));
  }
}

  public void erzeugeListeaufsteigend(int pAnzahl) {
    zaehler = 0;
    testListe = new List<Integer>();
    for (int i = 1; i <= pAnzahl; i++) {
      testListe.append(new Integer(i));
    }
  } 

  public void erzeugeListeabsteigend(int pAnzahl) {
    zaehler = 0;
    testListe = new List<Integer>();
    for (int i = pAnzahl; i > 0; i--) {
      testListe.append(new Integer(i));
    }
  }

  private void zaehle() {
    zaehler ++;
  }

  public int anzahlVergleiche() {
    return zaehler;
  }

public void sortiere1() {
  // Straight Insertion
  List<Integer> hilfsliste = new List<Integer>();         
  while (!testListe.isEmpty()) {
    testListe.toFirst();
    Integer aktueller = testListe.getContent();
    testListe.remove();
    hilfsliste.toFirst();
    boolean gefunden = false;
    while (!gefunden && hilfsliste.hasAccess()) {
      if (aktueller.intValue() < hilfsliste.getContent().intValue()) {
        gefunden = true;
      } else {
        hilfsliste.next();
      }
      zaehle();
    }
    if (hilfsliste.hasAccess()) {
      hilfsliste.insert(aktueller);
    } else {
      hilfsliste.append(aktueller);
    }
  }
  testListe.concat(hilfsliste);
}

  public void sortiere2() {
    // Quicksort
    testListe = quicksort(testListe);
  }

  private List<Integer> quicksort(List<Integer> pListe) {
    List<Integer> ergebnis = new List<Integer>();
    if (!pListe.isEmpty()) {
      pListe.toFirst();
      Integer pivot = pListe.getContent();
      pListe.remove();
      List<Integer> kleiner = new List<Integer>();
      List<Integer> groesser = new List<Integer>();
      while (!pListe.isEmpty()) {
        Integer aktuelles = pListe.getContent();
        if (aktuelles.intValue() < pivot.intValue()) {
          kleiner.append(aktuelles);
        } else {
          groesser.append(aktuelles);
        }
        zaehle();
        pListe.remove();
      }
      kleiner = quicksort(kleiner);
      groesser = quicksort(groesser);
      ergebnis = kleiner;
      ergebnis.append(pivot);
      ergebnis.concat(groesser);     
    }
    return ergebnis;
  }

  public void testeAlgorithmen() {
    System.out.println("StraightInsertion Quicksort zufaellig");
    for (int i = 100; i <= 1000; i = i + 100) {
      erzeugeZufallsliste(i);
      sortiere1();
      int anz1 = anzahlVergleiche();
      erzeugeZufallsliste(i);
      sortiere2();
      int anz2 = anzahlVergleiche();
      System.out.println(""+i+"\t"+anz1+"\t"+anz2);
    } 
    System.out.println("StraightInsertion Quicksort aufsteigend");
    for (int i = 100; i <= 1000; i = i + 100) {
      erzeugeListeaufsteigend(i);
      sortiere1();
      int anz1 = anzahlVergleiche();
      erzeugeListeaufsteigend(i);
      sortiere2();
      int anz2 = anzahlVergleiche();
      System.out.println(""+i+"\t"+anz1+"\t"+anz2);
    } 
    System.out.println("StraightInsertion Quicksort absteigend");
    for (int i = 100; i <= 1000; i = i + 100) {
      erzeugeListeabsteigend(i);
      sortiere1();
      int anz1 = anzahlVergleiche();
      erzeugeListeabsteigend(i);
      sortiere2();
      int anz2 = anzahlVergleiche();
      System.out.println(""+i+"\t"+anz1+"\t"+anz2);
    } 
  }

}

